function xls_2017(fname,co2_c,co2_cc,co2_b,co2_fr,co2_du,...
                          rsq_c,rsq_cc,rsq_b,rsq_h,rsq_fr,rsq_du,t_17,...
                          mgr_c,mgr_cc,mgr_b,mgr_hy,mgr_fr,mgr_du)
% Write MGR(t) data for 2017 into Excel spreadsheet

xlswrite(fname,co2_c,'2017 parameters','B3');
xlswrite(fname,co2_cc,'2017 parameters','C3');
xlswrite(fname,co2_b,'2017 parameters','D3');
xlswrite(fname,'0','2017 parameters','E3');
xlswrite(fname,co2_fr,'2017 parameters','F3');
xlswrite(fname,co2_du,'2017 parameters','G3');
headings = [cellstr('Coal'),cellstr('CCGT'),...
   cellstr('Biomass'),cellstr('Hydro'),cellstr('French'),cellstr('Dutch')];
xlswrite(fname,headings,'2017 parameters','B2');
xlswrite(fname,{'CO2 intensities (kg/kWh)'},...
           '2017 parameters','A1');
       
xlswrite(fname,rsq_c,'2017 parameters','B6');
xlswrite(fname,rsq_cc,'2017 parameters','C6');
xlswrite(fname,rsq_b,'2017 parameters','D6');
xlswrite(fname,rsq_h,'2017 parameters','E6');
xlswrite(fname,rsq_fr,'2017 parameters','F6');
xlswrite(fname,rsq_du,'2017 parameters','G6');
leftings = repmat([cellstr('<20');cellstr('20-22.5');...
    cellstr('22.5-25');cellstr('25-27.5');cellstr('27.5-30');...
    cellstr('30-32.5');cellstr('32.5-35');cellstr('35-37.5');...
    cellstr('37.5-40');cellstr('40-42.5');cellstr('42.5-45');...
    cellstr('45-47.5');cellstr('47.5-50');cellstr('50-52.5');...
    cellstr('>52.5')],12,1);
leftings = [{};leftings];
leftings(1:15:end) = [cellstr('Jan <20');cellstr('Feb <20');...
    cellstr('Mar <20');cellstr('Apr <20');cellstr('May <20');...
    cellstr('Jun <20');cellstr('Jul <20');cellstr('Aug <20');...
    cellstr('Sep <20');cellstr('Oct <20');cellstr('Nov <20');...
    cellstr('Dec <20')];
xlswrite(fname,leftings,'2017 parameters','A6');
xlswrite(fname,{'Demand bins (GW)'},'2017 parameters','A5');
xlswrite(fname,{'Coefficients of determination, R^2'},...
            '2017 parameters','B5');

N2 = length(t_17)+2;
d1=datestr(t_17);
d2=cellstr(d1(1,:));
for n=2:length(t_17)
  d2=[d2;cellstr(d1(n,:))];
end
xlswrite(fname,d2,'2017',['A3:A',num2str(N2)]);
xlswrite(fname,mgr_c','2017',['B3:B',num2str(N2)]);
xlswrite(fname,mgr_cc','2017',['C3:C',num2str(N2)]);
xlswrite(fname,mgr_b','2017',['D3:D',num2str(N2)]);
xlswrite(fname,mgr_hy','2017',['E3:E',num2str(N2)]);
xlswrite(fname,mgr_fr','2017',['F3:F',num2str(N2)]);
xlswrite(fname,mgr_du','2017',['G3:G',num2str(N2)]);
headings = [cellstr('Date/Time'),cellstr('Coal'),cellstr('CCGT'),...
   cellstr('Biomass'),cellstr('Hydro'),cellstr('French'),cellstr('Dutch')];
xlswrite(fname,headings,'2017','A2');
xlswrite(fname,{'2017 Marginal response (MW/MW)'},...
          '2017','A1');
      
xlswrite(fname,{'(kg/kWh)'},'2017','I1');  
xlswrite(fname,{'CO_2 MEF'},'2017','I2');  

% need to replicate formulae manually, sigh... v__v
for n=1:5
    xlswrite(fname,{['=B',num2str(n+2),'*''2017 parameters''!$B$3+C',...
        num2str(n+2),'*''2017 parameters''!$C$3+D',num2str(n+2),...
        '*''2017 parameters''!$D$3+E',num2str(n+2),...
        '*''2017 parameters''!$E$3+F',num2str(n+2),...
        '*''2017 parameters''!$F$3+G',num2str(n+2),...
        '*''2017 parameters''!$G$3']},'2017',['I',num2str(n+2)]);  
end

end

